/*****************************************/
/* Tetris                                */
/* (C) 2000, akop karapetyan             */
/*                                       */
/* Class Tetris                          */
/*   This is the actual applet. It does  */
/*   not do much other than load the gra-*/
/*   phics, and create the buffer(s),    */
/*   and initialize an instance of the   */
/*   Game class.                         */
/*****************************************/

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

public class Tetris extends Applet implements KeyListener {
	
	private Game game;				/* Instance of a game */
	
	/* Called by the browser whenever the applet inits */
	public void init() {
		String bgColor;
		Image[] images = new Image[5];
		
		MediaTracker tracker = new MediaTracker(this);
		
		bgColor = getParameter("background");
		resize(300, 370);

		addKeyListener(this);
		if (bgColor != null)
			setBackground(stringToColor(bgColor));
		
		/* Load block images */
		images[0] = getImage(getCodeBase(), "blocks.gif");
		tracker.addImage(images[0], 0);
		images[1] = getImage(getCodeBase(), "small.gif");
		tracker.addImage(images[1], 0);
		images[4] = getImage(getCodeBase(), "logo.gif");
		tracker.addImage(images[4], 0);
		
		/* Set up buffers for dbl-buffering */
		images[2] = createImage(195, 355);
		images[3] = createImage(85, 250);
		
		/* Wait for all the graphics to load */
		try { tracker.waitForAll(); } 
		catch( InterruptedException e ) {}
		
		/* Start the game! */
		game = new Game(this, images);
		add(game);
	}
	
	public void paint(Graphics g) {
	
		game.forceRepaint();
	}

	public void update(Graphics g) {

		paint(g);
	}

	/* Converts a string to a Color */
	private Color stringToColor(String paramValue) {
		
		int red = (Integer.decode("0x" + paramValue.substring(0,2))).intValue(),
			green = (Integer.decode("0x" + paramValue.substring(2,4))).intValue(),
			blue = (Integer.decode("0x" + paramValue.substring(4,6))).intValue();
		
		return new Color(red,green,blue);
	}
	
        public void keyPressed(KeyEvent e) {

                game.keyPressed(e);
        }

	public void keyTyped(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}

	public void destroy() {
		
		game.stopTimer();
	}
}
