/*****************************************/
/* Tetris                                */
/* (C) 2000, akop karapetyan             */
/*                                       */
/* Class Timer                           */
/*   The watchdog of time. Slightly mo-  */
/*   dified from Johan Andersson's Mine- */
/*   Applet game.                        */
/*****************************************/

class Timer implements Runnable {
	
	public boolean pause = true;	/* When set to true, ticks are ignored */
	public int interval = 1000;		/* Time (in millisecs) between ticks */

	private Thread thread = null;
	private Game owner = null;		/* The class that will notified at each tick */
	
	public Timer(Game theOwner) {
		
		owner = theOwner;
	}
	
	public void start() {
		
		if( thread == null ) {
			thread = new Thread( this, "TimerThread" );
			thread.setPriority( Thread.MAX_PRIORITY );
			thread.setDaemon( true );
			thread.start();
		}
	}
	
	public void stop() {
		
		if( thread != null ) {
	 		thread.stop();
			thread = null;
		}
	}
	
	public void run() {
		
		while( true ) {
			try {
				thread.sleep( interval );
				if (!pause)
					owner.tick();
			}
			catch( InterruptedException exception ) {}
		}
	}
}